;-----------------------------------------------;
;						;
;	Simple Character Processing Library	;
;						;
;	(C) October 4, 2006			;
;	Dr. William T. Verts			;
;						;
;-----------------------------------------------;

		.MODEL	SMALL

Backspace	EQU	8			; ASCII Control Character
Tab		EQU	9			; ASCII Control Character
LF		EQU	10			; ASCII Control Character
CR		EQU	13			; ASCII Control Character
Escape		EQU	27			; ASCII Control Character

;-----------------------------------------------;

		.DATA

;-----------------------------------------------;

		.CODE

		PUBLIC	Pause
		PUBLIC	Read_Char
		PUBLIC	Print_CRLF
		PUBLIC	Print_BKSP
		PUBLIC	Print_Greater
		PUBLIC	Print_Less
		PUBLIC	Print_Blank
		PUBLIC	Print_Tab
		PUBLIC	Print_CR
		PUBLIC	Print_LF
		PUBLIC	Print_Plus
		PUBLIC	Print_Minus
		PUBLIC	Print_Char

;-----------------------------------------------;
; Read a character until ESCAPE is entered	;
;-----------------------------------------------;

Pause		PROC	NEAR
		PUSH	AX
		PUSH	BX
		PUSH	CX
		PUSH	DX
		PUSH	SI
		PUSH	DI

     PauseLoop:	MOV	AX,0700H		; AL := ReadKey (no ^C check)
		INT	21H			;
		CMP	AL,ESCAPE		; Is Key = ESC ?
		JNE	PauseLoop		;

		POP	DI
		POP	SI
		POP	DX
		POP	CX
		POP	BX
		POP	AX
		RET
Pause		ENDP

;-----------------------------------------------;
; Read a character from keyboard into AX	;
;-----------------------------------------------;

Read_Char	PROC	NEAR
		PUSH	BX
		PUSH	CX
		PUSH	DX
		PUSH	SI
		PUSH	DI

		MOV	AX,0700H		; AL := ReadKey (no ^C check)
		INT	21H			;
		XOR	AH,AH			;

		POP	DI
		POP	SI
		POP	DX
		POP	CX
		POP	BX
		RET
Read_Char	ENDP

;-----------------------------------------------;

Print_CRLF	PROC	NEAR
		CALL	Print_CR
		CALL	Print_LF
		RET
Print_CRLF	ENDP

;-----------------------------------------------;

Print_BKSP	PROC	NEAR
		PUSH	AX
		MOV	AX,Backspace
		CALL	Print_Char
		POP	AX
		RET
Print_BKSP	ENDP

;-----------------------------------------------;

Print_Greater	PROC	NEAR
		PUSH	AX
		MOV	AX,'>'
		CALL	Print_Char
		POP	AX
		RET
Print_Greater	ENDP

;-----------------------------------------------;

Print_Less	PROC	NEAR
		PUSH	AX
		MOV	AX,'<'
		CALL	Print_Char
		POP	AX
		RET
Print_Less	ENDP

;-----------------------------------------------;

Print_Blank	PROC	NEAR
		PUSH	AX
		MOV	AX,' '
		CALL	Print_Char
		POP	AX
		RET
Print_Blank	ENDP

;-----------------------------------------------;

Print_Tab	PROC	NEAR
		PUSH	AX
		MOV	AX,Tab
		CALL	Print_Char
		POP	AX
		RET
Print_Tab	ENDP

;-----------------------------------------------;

Print_CR	PROC	NEAR
		PUSH	AX
		MOV	AX,CR
		CALL	Print_Char
		POP	AX
		RET
Print_CR	ENDP

;-----------------------------------------------;

Print_LF	PROC	NEAR
		PUSH	AX
		MOV	AX,LF
		CALL	Print_Char
		POP	AX
		RET
Print_LF	ENDP

;-----------------------------------------------;

Print_Plus	PROC	NEAR
		PUSH	AX
		MOV	AX,'+'
		CALL	Print_Char
		POP	AX
		RET
Print_Plus	ENDP

;-----------------------------------------------;

Print_Minus	PROC	NEAR
		PUSH	AX
		MOV	AX,'-'
		CALL	Print_Char
		POP	AX
		RET
Print_Minus	ENDP

;-----------------------------------------------;
; Print ASCII Character in AL			;
;-----------------------------------------------;

Print_Char:	PUSH	AX
		PUSH	BX
		PUSH	CX
		PUSH	DX
		PUSH	SI
		PUSH	DI

		MOV	DL,AL			; ASCII character must be in DL
		MOV	AH,2			;
		INT	21H			;

		POP	DI
		POP	SI
		POP	DX
		POP	CX
		POP	BX
		POP	AX
		RET

;-----------------------------------------------;

		END
